Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# TAO_UIOP_Profile Class Reference

This class defines the protocol specific attributes required for locating ORBs over local IPC. More...

`#include <UIOP_Profile.h>`

Inheritance diagram for TAO_UIOP_Profile:

[legend]
Collaboration diagram for TAO_UIOP_Profile:

[legend]
List of all members.

## Public Methods
virtual char | object_key_delimiter (void) const
| TAO_UIOP_Profile (const ACE_UNIX_Addr &addr, const TAO_ObjectKey &object_key, const TAO_GIOP_Message_Version &version, TAO_ORB_Core *orb_core)
| Profile constructor, same as above except the object_key has already been marshaled. (actually, no marshalling for this protocol). More...
| TAO_UIOP_Profile (const char *rendezvous_point, const TAO_ObjectKey &object_key, const ACE_UNIX_Addr &addr, const TAO_GIOP_Message_Version &version, TAO_ORB_Core *orb_core)
| Profile constructor. More...
| TAO_UIOP_Profile (TAO_ORB_Core *orb_core)
| Profile constructor, default. More...
| ~TAO_UIOP_Profile (void)
| Destructor is to be called only through <_decr_refcnt>. More...
virtual void | parse_string (const char *string ACE_ENV_ARG_DECL)
| Initialize this object using the given input string. More...
virtual char * | to_string (ACE_ENV_SINGLE_ARG_DECL)
| Return a string representation for this profile. client must deallocate memory. More...
virtual int | decode (TAO_InputCDR &cdr)
| Initialize this object using the given CDR octet string. More...
virtual int | encode (TAO_OutputCDR &stream) const
| Encode this profile in a stream, i.e. marshal it. More...
virtual int | encode_endpoints (void)
virtual const TAO_ObjectKey & | object_key (void) const
| Deprecated: Return a reference to the Object Key. More...
virtual TAO_ObjectKey * | _key (void) const
| Return a pointer to the Object Key. The caller owns the memory allocated for the returned key. More...
virtual TAO_Endpoint * | endpoint (void)
| Return pointer to the head of this profile's endpoints list. More...
virtual size_t | endpoint_count (void)
| Return how many endpoints this profile contains. More...
void | add_endpoint (TAO_UIOP_Endpoint *endp)
virtual CORBA::Boolean | is_equivalent (const TAO_Profile *other_profile)
virtual CORBA::ULong | hash (CORBA::ULong max ACE_ENV_ARG_DECL)
| Return a hash value for this object. More...
virtual IOP::TaggedProfile & | create_tagged_profile (void)
| Please see the Profile.h for the documentation of this method. More...
## Static Public Methods
const char * | prefix (void)
| Return the char string prefix. More...
## Static Public Attributes
const char | object_key_delimiter_ = '|'
| The object key delimiter that UIOP uses or expects. More...
## Private Methods
void | create_profile_body (TAO_OutputCDR &cdr) const
| Create an encapsulation of the struct ProfileBody in <cdr>. More...
int | decode_endpoints (void)
## Private Attributes
TAO_UIOP_Endpoint | endpoint_
size_t | count_
| Number of endpoints in the list headed by <endpoint_>. More...
TAO_ObjectKey | object_key_
| Object_key associated with this profile. More...
IOP::TaggedProfile | tagged_profile_
| Our tagged profile info. More...

## Detailed Description

This class defines the protocol specific attributes required for locating ORBs over local IPC.

This class defines the UIOP profile.

## Constructor & Destructor Documentation

TAO_UIOP_Profile::TAO_UIOP_Profile | ( | const ACE_UNIX_Addr & | addr,
|  | const TAO_ObjectKey & | object_key,
|  | const TAO_GIOP_Message_Version & | version,
|  | TAO_ORB_Core * | orb_core
| ) |

| Profile constructor, same as above except the object_key has already been marshaled. (actually, no marshalling for this protocol).

TAO_UIOP_Profile::TAO_UIOP_Profile | ( | const char * | rendezvous_point,
|  | const TAO_ObjectKey & | object_key,
|  | const ACE_UNIX_Addr & | addr,
|  | const TAO_GIOP_Message_Version & | version,
|  | TAO_ORB_Core * | orb_core
| ) |

| Profile constructor.

TAO_UIOP_Profile::TAO_UIOP_Profile | ( | TAO_ORB_Core * | orb_core | ) |

| Profile constructor, default.

TAO_UIOP_Profile::~TAO_UIOP_Profile | ( | void |  | ) |

| Destructor is to be called only through <_decr_refcnt>.

## Member Function Documentation

virtual TAO_ObjectKey* TAO_UIOP_Profile::_key | ( | void |  | ) | const`[virtual]`

| Return a pointer to the Object Key. The caller owns the memory allocated for the returned key. Reimplemented from TAO_Profile.

void TAO_UIOP_Profile::add_endpoint | ( | TAO_UIOP_Endpoint * | endp | ) |

| Add <endp> to this profile's list of endpoints (it is inserted next to the head of the list). This profiles takes ownership of <endp>.

void TAO_UIOP_Profile::create_profile_body | ( | TAO_OutputCDR & | encap | ) | const`[private]`

| Create an encapsulation of the struct ProfileBody in <cdr>.

IOP::TaggedProfile & TAO_UIOP_Profile::create_tagged_profile | ( | void |  | ) | `[virtual]`

| Please see the Profile.h for the documentation of this method. Reimplemented from TAO_Profile.

int TAO_UIOP_Profile::decode | ( | TAO_InputCDR & | cdr | ) | `[virtual]`

| Initialize this object using the given CDR octet string. Reimplemented from TAO_Profile.

int TAO_UIOP_Profile::decode_endpoints | ( | void |  | ) | `[private]`

| Helper for <decode>. Decodes endpoints from a tagged component. Decode only if RTCORBA is enabled. Furthermore, we may not find TAO_TAG_ENDPOINTS component, e.g., if we are talking to nonRT version of TAO or some other ORB. This is not an error, and we must proceed. Return 0 on success and -1 on failure.

int TAO_UIOP_Profile::encode | ( | TAO_OutputCDR & | stream | ) | const`[virtual]`

| Encode this profile in a stream, i.e. marshal it. Reimplemented from TAO_Profile.

int TAO_UIOP_Profile::encode_endpoints | ( | void |  | ) | `[virtual]`

| Encodes this profile's endpoints into a tagged component. This is done only if RTCORBA is enabled, since currently this is the only case when we have more than one endpoint per profile. Return 0 on success, -1 on failure. Endpoints are transmitted using TAO-proprietory tagged component. Component tag is TAO_TAG_ENDPOINTS and component data is an encapsulation of a sequence of structs, each representing a single endpoint. Data format is specified in uiop_endpoins.pidl. Multiple a la TAG_ALTERNATE_IIOP_ADDRESS components can be used instead of a single proprietory component to transmit multiple endpoints. This is somewhat slower and less convenient. Also, TAG_ALTERNATE_IIOP_ADDRESS does not provide for transmission of endpoint priorities. Reimplemented from TAO_Profile.

TAO_Endpoint * TAO_UIOP_Profile::endpoint | ( | void |  | ) | `[virtual]`

| Return pointer to the head of this profile's endpoints list. Reimplemented from TAO_Profile.

size_t TAO_UIOP_Profile::endpoint_count | ( | void |  | ) | `[virtual]`

| Return how many endpoints this profile contains. Reimplemented from TAO_Profile.

CORBA::ULong TAO_UIOP_Profile::hash | ( | CORBA::ULong max | ACE_ENV_ARG_DECL_NOT_USED | ) | `[virtual]`

| Return a hash value for this object. Reimplemented from TAO_Profile.

CORBA::Boolean TAO_UIOP_Profile::is_equivalent | ( | const TAO_Profile * | other_profile | ) | `[virtual]`

| Return true if this profile is equivalent to other_profile. Two profiles are equivalent iff their tag, object_key, version and all endpoints are the same. Reimplemented from TAO_Profile.

virtual const TAO_ObjectKey& TAO_UIOP_Profile::object_key | ( | void |  | ) | const`[virtual]`

| Deprecated: Return a reference to the Object Key. Reimplemented from TAO_Profile.

char TAO_UIOP_Profile::object_key_delimiter | ( | void |  | ) | const`[virtual]`

| Reimplemented from TAO_Profile.

void TAO_UIOP_Profile::parse_string | ( | const char *string | ACE_ENV_ARG_DECL | ) | `[virtual]`

| Initialize this object using the given input string. Reimplemented from TAO_Profile.

const char * TAO_UIOP_Profile::prefix | ( | void |  | ) | `[static]`

| Return the char string prefix.

char * TAO_UIOP_Profile::to_string | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) | `[virtual]`

| Return a string representation for this profile. client must deallocate memory. Reimplemented from TAO_Profile.

## Member Data Documentation

size_t TAO_UIOP_Profile::count_`[private]`

| Number of endpoints in the list headed by <endpoint_>.

TAO_UIOP_Endpoint TAO_UIOP_Profile::endpoint_`[private]`

| Head of this profile's list of endpoints. This endpoint is not dynamically allocated because a profile always contains at least one endpoint. Currently, a profile contains more than one endpoint, i.e., list contains more than just the head, only when RTCORBA is enabled. However, in the near future, this will be used in nonRT mode as well, e.g., to support a la TAG_ALTERNATE_IIOP_ADDRESS feature. Addressing info of the default endpoint, i.e., head of the list, is transmitted using standard UIOP ProfileBody components. See <encode_endpoints> method documentation above for how the rest of the endpoint list is transmitted.

TAO_ObjectKey TAO_UIOP_Profile::object_key_`[private]`

| Object_key associated with this profile.

const char TAO_UIOP_Profile::object_key_delimiter_ = '|'`[static]`

| The object key delimiter that UIOP uses or expects.

IOP::TaggedProfile TAO_UIOP_Profile::tagged_profile_`[private]`

| Our tagged profile info.

The documentation for this class was generated from the following files:

- UIOP_Profile.h
- UIOP_Profile.cpp